## 4.0.1 (2018-05-03)
[Compare `@uirouter/angular-hybrid` versions 4.0.0 and 4.0.1](https://github.com/ui-router/angular-hybrid/compare/4.0.0...4.0.1)

### Bug Fixes

* **README:** Update bootstrap directions to avoid 'digest already in progress' errors ([9df20f0](https://github.com/ui-router/angular-hybrid/commit/9df20f0))


### Updated `@uirouter/core` from 5.0.17 to 5.0.18
[Compare `@uirouter/core` versions 5.0.17 and 5.0.18](https://github.com/ui-router/core/compare/5.0.17...5.0.18)

### Bug Fixes

* **angular:** A hack to force the Angular compiler to import from module index ([d56a2be](https://github.com/ui-router/core/commit/d56a2be))
* **StateRegistry:** Notify listeners of added states when there are orphans in the state queue ([5a9bac9](https://github.com/ui-router/core/commit/5a9bac9))
* **transition:** Fix typing of Transition.params() ([ebea30e](https://github.com/ui-router/core/commit/ebea30e))
* **transition:** Normalize `error()` to always return `Rejection` ([9bcc5db](https://github.com/ui-router/core/commit/9bcc5db))


### Updated `@uirouter/angular` from 1.0.1 to 1.1.0
[Compare `@uirouter/angular` versions 1.0.1 and 1.1.0](https://github.com/ui-router/angular/compare/1.0.1...1.1.0)

### Bug Fixes

* **uiSref:** Ignore clicks if destination state is falsey ([b599e72](https://github.com/ui-router/angular/commit/b599e72))
* **uiView:** Always inject and/or bind NOWAIT resolve as a Promise object. ([42d739d](https://github.com/ui-router/angular/commit/42d739d))


### Features

* **uiView:** Add uiOnParamsChanged support for routed components ([45aa2aa](https://github.com/ui-router/angular/commit/45aa2aa))


### Updated `@uirouter/angularjs` from 1.0.15 to 1.0.16
[Compare `@uirouter/angularjs` versions 1.0.15 and 1.0.16](https://github.com/angular-ui/ui-router/compare/1.0.15...1.0.16)

### Bug Fixes

* **docs:** downgrade to [@types](https://github.com/types)/angular[@1](https://github.com/1).6.25 to fix typings error when generating docs ([5850136](https://github.com/angular-ui/ui-router/commit/5850136))

# 4.0.0 (2018-02-15)
[Compare `@uirouter/angular-hybrid` versions 3.1.10 and 4.0.0](https://github.com/ui-router/angular-hybrid/compare/3.1.10...4.0.0)

### Bug Fixes

* **package:** Move types/* dependencies to devDependencies ([9c87ae6](https://github.com/ui-router/angular-hybrid/commit/9c87ae6))


### Features

* **NgModule:** Add UIRouterUpgradeModule.forChild() ([a867ffb](https://github.com/ui-router/angular-hybrid/commit/a867ffb))
* **typings:** add types for hybrid state declaration ([f5a6c73](https://github.com/ui-router/angular-hybrid/commit/f5a6c73))


### BREAKING CHANGES

* **NgModule:** - Remove standalone import of `UIRouterUpgradeModule`.
- Use `UIRouterUpgradeModule.forChild()` instead of `UIRouterModule.forChild()`.
- Cast states as `NgHybridStateDeclaration`.

The `angular-hybrid` library processes state's `onEnter`/`onExit`/`onRetain` as AngularJS style injected functions.  However, the typescript typings when using `UIRouterModule.forChild()` were not compatible with AngularJS style injected callbacks.  This release adds typings supporting AngularJS style callbacks on state declarations.

```ts
export const mystate: NgHybridStateDeclaration = {  // cast
  name: 'mystate',
  url: '/mystate',
  component: MyAngularComponent,
  onEnter: myStateOnEnter,
};

myStateOnEnter.$inject = ['$state'];
export function myStateOnEnter($state) {
  console.log('$state was injected', $state);
}

@NgModule({
  imports: [
    BrowserModule,
    UpgradeModule,
    // remove this: UIRouterUpgradeModule,
    // remove this: UIRouterModule.forChild( ... ),
    UIRouterUpgradeModule.forChild({ states: [mystate] }), // replace with this
  ]
})
```

## 3.1.10 (2018-02-12)
[Compare `@uirouter/angular-hybrid` versions 3.1.9 and 3.1.10](https://github.com/ui-router/angular-hybrid/compare/3.1.9...3.1.10)


### Updated `@uirouter/core` from 5.0.16 to 5.0.17
[Compare `@uirouter/core` versions 5.0.16 and 5.0.17](https://github.com/ui-router/core/compare/5.0.16...5.0.17)

### Bug Fixes

* **core:** Fix leak of old transitions by mutating pathnode*.resolvables*.data ([0a1f518](https://github.com/ui-router/core/commit/0a1f518))


### Updated `@uirouter/angular` from 1.0.0 to 1.0.1
[Compare `@uirouter/angular` versions 1.0.0 and 1.0.1](https://github.com/ui-router/ng2/compare/1.0.0...1.0.1)

### Bug Fixes

* **package:** update [@uirouter](https://github.com/uirouter)/core to version 5.0.17 ([f018f35](https://github.com/ui-router/ng2/commit/f018f35))
* **uiSrefActive:** Support multiple active classes ([e086700](https://github.com/ui-router/ng2/commit/e086700))


### Updated `@uirouter/angularjs` from 1.0.14 to 1.0.15
[Compare `@uirouter/angularjs` versions 1.0.14 and 1.0.15](https://github.com/angular-ui/ui-router/compare/1.0.14...1.0.15)

### Bug Fixes

* **package:** update [@uirouter](https://github.com/uirouter)/core to version 5.0.17 ([1b54264](https://github.com/angular-ui/ui-router/commit/1b54264))

## 3.1.9 (2018-01-31)
[Compare `@uirouter/angular-hybrid` versions 3.1.8 and 3.1.9](https://github.com/ui-router/angular-hybrid/compare/3.1.8...3.1.9)

### Bug Fixes

* **greenkeeper:** pin angular dev deps to 4.x, update ui-router deps, update rollup config ([c157551](https://github.com/ui-router/angular-hybrid/commit/c157551))


### Updated `@uirouter/core` from 5.0.11 to 5.0.16
[Compare `@uirouter/core` versions 5.0.11 and 5.0.16](https://github.com/ui-router/core/compare/5.0.11...5.0.16)

### Bug Fixes

* **browserLocation:** Use location.pathname (not href) or '/' when no base tag found ([db461d6](https://github.com/ui-router/core/commit/db461d6))
* **browserLocationConfig:** If no base href found, use location.href (not empty string) ([0251424](https://github.com/ui-router/core/commit/0251424))
* **common:** Fix signature of  for objects (make target optional) ([61d0afc](https://github.com/ui-router/core/commit/61d0afc))
* **core:** Fix memory leak of resolve data from ALL transitions ever ([7f2aed1](https://github.com/ui-router/core/commit/7f2aed1))
* **pathNode:** add backwards compat for PathNode.clone(). Add retainedWithToParams to treeChanges interface. ([4833a32](https://github.com/ui-router/core/commit/4833a32))
* **pushStateLocation:** Fix URLs: add slash between base and path when necessary ([bfa5755](https://github.com/ui-router/core/commit/bfa5755))
* **pushStateLocation:** When url is "" or "/", use baseHref for pushState ([042a950](https://github.com/ui-router/core/commit/042a950))
* **resolve:** Add onFinish hook to resolve any dynamicly added resolvables ([7d1ca54](https://github.com/ui-router/core/commit/7d1ca54))
* **trace:** Fix null reference in uiview name sort function ([59cb067](https://github.com/ui-router/core/commit/59cb067))
* **treeChanges:** apply toParams to 'retained' path ([#72](https://github.com/ui-router/core/issues/72)) ([cf63d11](https://github.com/ui-router/core/commit/cf63d11))
* **urlRouter:** Update query params when resetting url via .update() ([7664cd0](https://github.com/ui-router/core/commit/7664cd0))


### Features

* **common:** Add map-in-place support to map() ([12bc7d8](https://github.com/ui-router/core/commit/12bc7d8))
* **common:** Add onEvict() callback registry for queues with max length ([c19d007](https://github.com/ui-router/core/commit/c19d007))
* **view:** Add onSync callback API to plugin API ([9544ae5](https://github.com/ui-router/core/commit/9544ae5))


### Updated `@uirouter/angular` from 1.0.0-rc.1 to 1.0.0
[Compare `@uirouter/angular` versions 1.0.0-rc.1 and 1.0.0](https://github.com/ui-router/ng2/compare/1.0.0-rc.1...1.0.0)

### Bug Fixes

* **hooks:** Use an APP_INITIALIZER to sync/listen to the URL ([f1d390f](https://github.com/ui-router/ng2/commit/f1d390f))
* **package:** Bump dependency on uirouter/publish-scripts to fix npm install ([1a026d2](https://github.com/ui-router/ng2/commit/1a026d2))
* **package:** update [@uirouter](https://github.com/uirouter)/core to version 5.0.13 ([90aa1d4](https://github.com/ui-router/ng2/commit/90aa1d4))


### Features

* **uiSref:** Add support for ctrl/middle-clicking on a uiSref generated URL ([#175](https://github.com/ui-router/ng2/issues/175)) ([973924a](https://github.com/ui-router/ng2/commit/973924a))


### Updated `@uirouter/angularjs` from 1.0.11 to 1.0.14
[Compare `@uirouter/angularjs` versions 1.0.11 and 1.0.14](https://github.com/angular-ui/ui-router/compare/1.0.11...1.0.14)

### Bug Fixes

* **location:** allow empty string param: Ng1LocationServices.url('') ([01bbaf0](https://github.com/angular-ui/ui-router/commit/01bbaf0))
* **onEnter:** Do not inject child-state data into ng1 onEnter hooks ([cdec6a0](https://github.com/angular-ui/ui-router/commit/cdec6a0))
* **package:** update [@uirouter](https://github.com/uirouter)/core to version 5.0.13 ([6c63f2d](https://github.com/angular-ui/ui-router/commit/6c63f2d))
* **travis:** regenerate and encrypt secret ([c718ce5](https://github.com/angular-ui/ui-router/commit/c718ce5))
* **uiSrefActive:** don't match fuzzy on lazy loaded future states ([01430ee](https://github.com/angular-ui/ui-router/commit/01430ee))


### Features

* **uiSrefActive:** Support arrays of globs for ng-class style ([b215343](https://github.com/angular-ui/ui-router/commit/b215343))

## 3.1.8 (2017-12-07)
[Compare `@uirouter/angular-hybrid` versions 3.1.7 and 3.1.8](https://github.com/ui-router/angular-hybrid/compare/3.1.7...3.1.8)

### Bug Fixes

* **types:** Add types/angular and types/jquery as top level dependency. ([f00d5cf](https://github.com/ui-router/angular-hybrid/commit/f00d5cf)), closes [#58](https://github.com/ui-router/angular-hybrid/issues/58)
* **uiView:** Use useFactory instead of useValue when to prevent object re-use within PARENT_INJECT for different UIViews ([3087be9](https://github.com/ui-router/angular-hybrid/commit/3087be9))


### Features

* **angular-hybrid:** Fix peer dependencies. Update package deps. ([d09949d](https://github.com/ui-router/angular-hybrid/commit/d09949d))


### Updated `@uirouter/angular` from 1.0.0-beta.9 to 1.0.0-rc.1
[Compare `@uirouter/angular` versions 1.0.0-beta.9 and 1.0.0-rc.1](https://github.com/ui-router/ng2/compare/1.0.0-beta.9...1.0.0-rc.1)

### Bug Fixes

* **package:** Rebuild uirouter/angular using angular 4.4.6 ([a39aed8](https://github.com/ui-router/ng2/commit/a39aed8))
* **package.json:** npm shrinkwarp with angular 5 ([477d0f7](https://github.com/ui-router/ng2/commit/477d0f7))
* **uiView:** Fix animations :enter trigger by using markForCheck ([3d7ce44](https://github.com/ui-router/ng2/commit/3d7ce44))


### Features

* **directives:** Export directives using `exportAs:` for use as template variables ([3d532b6](https://github.com/ui-router/ng2/commit/3d532b6))
* **lazyLoad:** Allow loadChildren for non-future states. ([ac3cdef](https://github.com/ui-router/ng2/commit/ac3cdef))
* **uiView:** add getter for state which is filling the uiview ([e7cb5f1](https://github.com/ui-router/ng2/commit/e7cb5f1))


### Updated `@uirouter/angularjs` from 1.0.9 to 1.0.11
[Compare `@uirouter/angularjs` versions 1.0.9 and 1.0.11](https://github.com/angular-ui/ui-router/compare/1.0.9...1.0.11)

### Bug Fixes

* **artifactory:** Add trailing newline to package.json to work around artifactory issue  ([#3551](https://github.com/angular-ui/ui-router/issues/3551)) ([d09a345](https://github.com/angular-ui/ui-router/commit/d09a345)), closes [#3550](https://github.com/angular-ui/ui-router/issues/3550)
* **uiView:** Fix cfg.getTemplate is undefined ([f4d99b0](https://github.com/angular-ui/ui-router/commit/f4d99b0))

## 3.1.7 (2017-10-17)
[Compare `@uirouter/angular-hybrid` versions 3.1.5 and 3.1.7](https://github.com/ui-router/angular-hybrid/compare/3.1.5...3.1.7)


### Updated `@uirouter/core` from 5.0.10 to 5.0.11
[Compare `@uirouter/core` versions 5.0.10 and 5.0.11](https://github.com/ui-router/core/compare/5.0.10...5.0.11)

### Bug Fixes

* **ie9:** make console.bind work in ie9 ([#85](https://github.com/ui-router/core/issues/85)) ([318214b](https://github.com/ui-router/core/commit/318214b))


### Updated `@uirouter/angular` from 1.0.0-beta.8 to 1.0.0-beta.9
[Compare `@uirouter/angular` versions 1.0.0-beta.8 and 1.0.0-beta.9](https://github.com/ui-router/ng2/compare/1.0.0-beta.8...1.0.0-beta.9)

### Features

* **UIRouterModule:** Add `initial` property to `forRoot` to specify the initial route. ([b7b5e4f](https://github.com/ui-router/ng2/commit/b7b5e4f))


### Updated `@uirouter/angularjs` from 1.0.8 to 1.0.9
[Compare `@uirouter/angularjs` versions 1.0.8 and 1.0.9](https://github.com/angular-ui/ui-router/compare/1.0.8...1.0.9)

## 3.1.5 (2017-10-07)
[Compare `@uirouter/angular-hybrid` versions 3.1.4 and 3.1.5](https://github.com/ui-router/angular-hybrid/compare/3.1.4...3.1.5)

Updates:

- `@uirouter/angularjs` to 1.0.8
- `@uirouter/angular` to 1.0.0-beta.8
- `@uirouter/core` to 5.0.10

### Bug Fixes

* **hybrid:** Do not import angular/upgrade ([eb83724](https://github.com/ui-router/angular-hybrid/commit/eb83724))
* **typings:** Fix typing error in `uiRouterUpgradeFactory` ([f361d7a](https://github.com/ui-router/angular-hybrid/commit/f361d7a))



<a name="3.1.4"></a>
## 3.1.4 (2017-08-15)

* fix(package): Fix manifest -- location of es6 modules is lib/index not lib-esm/index ([040722c](https://github.com/ui-router/angular-hybrid/commit/040722c))



<a name="3.1.3"></a>
## 3.1.3 (2017-08-13)

* fix(build): Depend on NPM packages instead of git tags ([b9261af](https://github.com/ui-router/angular-hybrid/commit/b9261af))
* Create README.md ([d59d2f9](https://github.com/ui-router/angular-hybrid/commit/d59d2f9))
* chore(): update changelog ([e4d29d4](https://github.com/ui-router/angular-hybrid/commit/e4d29d4))
* chore(example): Added minimal example ([a8ee08f](https://github.com/ui-router/angular-hybrid/commit/a8ee08f))



<a name="3.1.2"></a>
## 3.1.2 (2017-06-12)

Rebuilt with newer snapshots of @uirouter/angular and @uirouter/angularjs

* chore(example): Added minimal example ([425815d](https://github.com/ui-router/angular-hybrid/commit/425815d))


<a name="3.1.1"></a>
## 3.1.1 (2017-05-22)

Fix missing dev dependency from 3.1.0 release

* chore(deps): Add @angular/compiler-cli ([7a893ba](https://github.com/ui-router/angular-hybrid/commit/7a893ba))



<a name="3.1.0"></a>
# 3.1.0 (2017-05-22)

This version of @uirouter/angular-upgrade supports ahead of time compilation, and lazy loading
of Angular future states via @ngtools/webpack

* fix(AoT): Make angular-hybrid.ts compatible with ngc ([dcf10a2](https://github.com/ui-router/angular-hybrid/commit/dcf10a2))
* fix(AoT): Make hybrid adapter AoT compatible ([e79866a](https://github.com/ui-router/angular-hybrid/commit/e79866a))
* Correct package name in example ([877953f](https://github.com/ui-router/angular-hybrid/commit/877953f))
* Update README.md ([6c75e4b](https://github.com/ui-router/angular-hybrid/commit/6c75e4b))
* doc(*): update README ([18ec03f](https://github.com/ui-router/angular-hybrid/commit/18ec03f))



<a name="3.0.1"></a>
## 3.0.1 (2017-05-16)

* feat(Ng1ToNg2Module): Rename Ng1ToNg2Module to UIRouterUpgradeModule ([fcac2f9](https://github.com/ui-router/angular-hybrid/commit/fcac2f9))


### BREAKING CHANGE

* Rename Ng1ToNg2Module to UIRouterUpgradeModule
(This was supposed to land in version 3.0.0)


<a name="3.0.0"></a>
# 3.0.0 (2017-05-16)

* chore(*): Fix botched merge and re-add ng2LazyLoadBuilder ([8596e2a](https://github.com/ui-router/angular-hybrid/commit/8596e2a))
* chore(*): fix some code comments ([83bc525](https://github.com/ui-router/angular-hybrid/commit/83bc525))
* chore(build): remove old release script ([7128857](https://github.com/ui-router/angular-hybrid/commit/7128857))
* chore(build): tweak npm ignore ([788b5ed](https://github.com/ui-router/angular-hybrid/commit/788b5ed))
* chore(build): update .npmignore ([5a18fe2](https://github.com/ui-router/angular-hybrid/commit/5a18fe2))
* chore(README): Update README ([76aa21a](https://github.com/ui-router/angular-hybrid/commit/76aa21a))
* chore(README): Update README with info about migration to @angular/upgrade/static ([215160a](https://github.com/ui-router/angular-hybrid/commit/215160a))
* feat(ngUpgrade): Add support for @angular/upgrade/static ([4b7fce0](https://github.com/ui-router/angular-hybrid/commit/4b7fce0))
* feat(upgrade): Version 3.x uses @angular/upgrade/static ([1d60e5b](https://github.com/ui-router/angular-hybrid/commit/1d60e5b))
* refactor(static): Clean up imports and switch let to const ([4a0dcaf](https://github.com/ui-router/angular-hybrid/commit/4a0dcaf))
* fix(ngModule): Revert breaking change of module name ([7a37c4a](https://github.com/ui-router/angular-hybrid/commit/7a37c4a))
* fix(static): Remove setup call and get the ng2 injector from ng1 ([27fa6dc](https://github.com/ui-router/angular-hybrid/commit/27fa6dc))
* Specify inputs for downgraded uiViewNgUpgrade ([a47445d](https://github.com/ui-router/angular-hybrid/commit/a47445d))
* Update README.md ([48bad58](https://github.com/ui-router/angular-hybrid/commit/48bad58))


### BREAKING CHANGE

* use `@angular/upgrade/static`
Version 3.0.0 and higher no longer supports `@angular/upgrade`.
We now support only `@angular/upgrade/static`

Your bootstrap process will change.
For details, please see [the sample app](https://github.com/ui-router/sample-app-ng1-to-ng2/commit/2e5accf7799ff48cae048d18383e8dedadd99b41) to see how to migrate your bootstrap to the new style.

Angular no longer actively supports the old `UpgradeAdapter`.
The [currently supported mechanism](https://angular.io/docs/ts/latest/guide/upgrade.html) is `UpgradeModule` from `@angular/upgrade/static`


<a name="2.0.0"></a>
# 2.0.0 (2017-05-13)

* chore(*): bump deps to artifact tags ([550d2ea](https://github.com/ui-router/angular-hybrid/commit/550d2ea))
* chore(*): bumping version to 2.0.0 ([f8003d8](https://github.com/ui-router/angular-hybrid/commit/f8003d8))
* chore(build): Add rollup build file ([8955496](https://github.com/ui-router/angular-hybrid/commit/8955496))
* chore(build): Add scripts dir ([29b2824](https://github.com/ui-router/angular-hybrid/commit/29b2824))
* chore(build): Add UMD module name mappings ([b0c7eed](https://github.com/ui-router/angular-hybrid/commit/b0c7eed))
* chore(build): bump dependencies ([943ac95](https://github.com/ui-router/angular-hybrid/commit/943ac95))
* chore(build): Remove incorrect rollup config ([a3c0fb9](https://github.com/ui-router/angular-hybrid/commit/a3c0fb9))
* chore(travis): Build package with travis ([3948ae2](https://github.com/ui-router/angular-hybrid/commit/3948ae2))
* fix(*): Update for split repositories. Update to ui-router-ng2 1.0.0-beta.4, angular-ui-router 1.0.0 ([4e1050e](https://github.com/ui-router/angular-hybrid/commit/4e1050e))
* fix(angular4): Update hybrid adapter with new DI token for angular injector ([8a85fc0](https://github.com/ui-router/angular-hybrid/commit/8a85fc0))
* fix(build): Switch tsconfig back to module: commonjs ([1b20157](https://github.com/ui-router/angular-hybrid/commit/1b20157))
* fix(ng1-to-ng2): Add ui-router-rx plugin and ng2 loadChildren decorator ([dc58311](https://github.com/ui-router/angular-hybrid/commit/dc58311))
* fix(package): Add prepublish build step allowing installs from git ([c7c693c](https://github.com/ui-router/angular-hybrid/commit/c7c693c))
* feat(hybrid): rename npm package to @uirouter/angular-hybrid. Update project to use latest @uirouter ([6b06e86](https://github.com/ui-router/angular-hybrid/commit/6b06e86))
* Add artifact tagging script ([abfbe9e](https://github.com/ui-router/angular-hybrid/commit/abfbe9e))
* Typo, should be Angular 1 to Angular *2* ([c466cae](https://github.com/ui-router/angular-hybrid/commit/c466cae))
* Update CHANGELOG.md ([14be8a9](https://github.com/ui-router/angular-hybrid/commit/14be8a9))
* bug(*): fix State renamed to StateObject ([50677d1](https://github.com/ui-router/angular-hybrid/commit/50677d1))


### BREAKING CHANGE

* Project name switched from `ui-router-ng1-to-ng2` to `@uirouter/angular-hybrid`

bundle moved to `_bundles/ui-router-angular-hybrid.js`


See: https://github.com/ui-router/ng1-to-ng2/releases
